PUBLIC osample1
osample1=NEWOBJECT("sample1")
osample1.SHOW

DEFINE CLASS sample1 AS FORM

  HEIGHT = 447
  WIDTH = 633
  CAPTION = "Sample 1 - GDI+ FoxTalk Series"
  surfacex = 0
  surfacey = 0
  originalxcoord = 0
  originalycoord = 0
  NAME = "Sample1"

  PROCEDURE drawshapes
*!* #DEFINE UNITDISPLAY 1
    #DEFINE UNITPIXEL 2 && This is the one I'll be using
*!* #DEFINE UNITPOINT 3
*!* #DEFINE UNITINCH 4
*!* #DEFINE UNITDOCUMENT 5
*!* #DEFINE UNITMILLIMETER 6
    #DEFINE IMAGEOFFSET 50
    DIMENSION aryPoints(4,2)
    LOCAL loGPColor, loGPPen, loGPRect, loGPGraphics, loGPImage
    WITH THIS
      loGPColor = CREATEOBJECT("gpColor", 255, 0, 0, 255) && INIT Params (Red, Green, Blue, and Alpha)
      loGPPen = CREATEOBJECT("gpPen", loGPColor.ARGB, 8, UNITPIXEL) && INIT Params (ARGB Color, Pen Width, Unit of Measure)
      loGPRect = CREATEOBJECT("gpRectangle", ;
      	.surfacex + 5, .surfacey + 5, .WIDTH - 10, ;
            .HEIGHT - 10) && INIT Params(X-Coordinate, Y-Coordinate, Width, Height)
      loGPGraphics = CREATEOBJECT("gpGraphics")
      loGPGraphics.CreateFromHWND(.HWND)
      loGPGraphics.CLEAR(0xFFFFFFFF)
      loGPGraphics.DrawRectangle(loGPPen, loGPRect)
      aryPoints(1,1) = .WIDTH/2 + .surfacex
      aryPoints(1,2) = .surfacey
      aryPoints(2,1) = .WIDTH + .surfacex - 1
      aryPoints(2,2) = .HEIGHT/2 + .surfacey
      aryPoints(3,1) = aryPoints(1,1)
      aryPoints(3,2) = .HEIGHT + .surfacey - 1
      aryPoints(4,1) = .surfacex
      aryPoints(4,2) = aryPoints(2,2)
      loGPColor.Red = 0
      loGPSolidBrush = CREATEOBJECT("gpSolidBrush", loGPColor)
      loGPGraphics.FillPolygon(loGPSolidBrush, @aryPoints, 1, 1)
      loGPImage = CREATEOBJECT("gpImage")
      loGPImage.CreateFromFile(HOME(4) + "Gifs\morphfox.gif", .T.)
      loGPGraphics.DrawImageAt(loGPImage, .WIDTH/2 - ;
            IMAGEOFFSET + .surfacex -10, .HEIGHT/2 - ;
            IMAGEOFFSET + .surfacey -10)
    ENDWITH
  ENDPROC

  PROCEDURE MOUSEMOVE
    LPARAMETERS nButton, nShift, nXCoord, nYCoord
    IF nButton = 2
      WITH THIS
        .surfacex = .surfacex + (nXCoord - .originalxcoord)
        .surfacey = .surfacey + (nYCoord - .originalycoord)
        .originalxcoord = nXCoord
        .originalycoord = nYCoord
        .drawshapes()
      ENDWITH
    ELSE
      THIS.MOUSEPOINTER= 0
    ENDIF
  ENDPROC

  PROCEDURE MOUSEDOWN
    LPARAMETERS nButton, nShift, nXCoord, nYCoord
    IF nButton = 2
      WITH THIS
        .MOUSEPOINTER= 15
        .originalxcoord = nXCoord
        .originalycoord = nYCoord
      ENDWITH
    ENDIF
  ENDPROC

  PROCEDURE LOAD
    SET CLASSLIB TO (HOME(1) + "FFC\_gdiplus.vcx")
  ENDPROC

  PROCEDURE PAINT
    THIS.drawshapes()
  ENDPROC

ENDDEFINE
