PUBLIC osample2
osample2=NEWOBJECT("sample2")
osample2.SHOW

DEFINE CLASS sample2 AS FORM
	TOP = 0
	LEFT = 0
	HEIGHT = 447
	WIDTH = 633
	DOCREATE = .T.
	CAPTION = "Sample 2 - GDI+ FoxTalk Series"
	surfacex = 0
	surfacey = 0
	originalxcoord = 0
	originalycoord = 0
	realhwnd = 0
	*!* winprocaddress = 0
	gpbitmap = NULL
	gpcolor = NULL
	gppen = NULL
	gprect = NULL
	gpgraphicsdb = NULL
	gpsolidbrush = NULL
	gpgraphics = NULL
	gpimage = NULL
	NAME = "Sample2"

	PROCEDURE drawshapes
		#DEFINE IMAGEOFFSET 50
		WITH THIS
			IF .WIDTH > 0 AND .HEIGHT > 0
				.gpgraphicsdb.CLEAR(0xFFFFFFFF)
				.gpgraphicsdb.DrawRectangle(.gppen, .gprect)
				.gpgraphicsdb.FillPolygon(.gpsolidbrush, @aryPoints, 1, 1)
				.gpgraphicsdb.DrawImageAt(.gpimage, .WIDTH/2 - IMAGEOFFSET + .surfacex - 10, .HEIGHT/2 - IMAGEOFFSET + .surfacey - 10)
				.gpgraphics.CreateFromHWND(.realhwnd)
				IF .gpgraphics.gethandle() > 0
					.gpgraphics.DrawImageAt(.gpbitmap, 0, 0)
				ENDIF
			ENDIF
		ENDWITH
	ENDPROC

	PROCEDURE wineventhandler
		LPARAMETERS HWND, msg, wParam, LPARAM
		#DEFINE WM_ERASEBKGND 0x0014
		#DEFINE WM_PAINT 0x000F

		LOCAL lvHDC, lvPaintStruct

		DO CASE
			CASE msg = WM_PAINT
				*!*        DefWindowProc(HWND, msg, wParam, lParam)
				lvPaintStruct = SPACE(56)
				=BeginPaint(HWND, @lvPaintStruct) && Returns HDC
				THIS.drawshapes()
				=EndPaint(HWND, @lvPaintStruct) && Returns HDC
			CASE msg = WM_ERASEBKGND
				RETURN 1
			OTHERWISE
				*!*        CallWindowProc(THIS.WinProcAddress, HWND, msg, wParam, lParam)
		ENDCASE
	ENDPROC

	PROCEDURE creategpobjects
		#DEFINE UNITPIXEL 2
		WITH THIS
			.gpimage = CREATEOBJECT("gpImage")
			.gpimage.CreateFromFile(HOME(4) + "Gifs\morphfox.gif", .T.)
			.gpbitmap = CREATEOBJECT("gpBitmap")
			.gpcolor = CREATEOBJECT("gpColor", 255, 0, 0, 255) && INIT Params (Red, Green, Blue, and Alpha)
			.gppen = CREATEOBJECT("gpPen", .gpcolor.ARGB, 8, UNITPIXEL) && INIT Params (ARGB Color, Pen Width, Unit of Measure)
			.gprect = CREATEOBJECT("gpRectangle", 0, 0, 0, 0) && INIT Params (X-Coordinate, Y-Coordinate, Width, Height)
			.gpgraphicsdb = CREATEOBJECT("gpGraphics")
			.gpcolor.Red = 0
			.gpsolidbrush = CREATEOBJECT("gpSolidBrush", .gpcolor)
			.gpgraphics = CREATEOBJECT("gpGraphics")
		ENDWITH
	ENDPROC

	PROCEDURE resetgpobjects
		WITH THIS
			.gpbitmap.CREATE(.WIDTH, .HEIGHT)
			.gpgraphicsdb.CreateFromImage(.gpbitmap)
			.gprect.X = .surfacex + 5
			.gprect.Y = .surfacey + 5
			.gprect.X2 = .WIDTH + .surfacex - 5
			.gprect.Y2 = .HEIGHT + .surfacey - 5
			aryPoints(1,1) = .WIDTH/2 + .surfacex
			aryPoints(1,2) = .surfacey
			aryPoints(2,1) = .WIDTH + .surfacex - 1
			aryPoints(2,2) = .HEIGHT/2 + .surfacey
			aryPoints(3,1) = aryPoints(1,1)
			aryPoints(3,2) = .HEIGHT+ .surfacey - 1
			aryPoints(4,1) = .surfacex
			aryPoints(4,2) = aryPoints(2,2)
		ENDWITH
	ENDPROC

	PROCEDURE LOAD
		PUBLIC ARRAY aryPoints(4,2)
		DECLARE LONG BeginPaint IN User32 LONG HWND, STRING @lpPaint
		DECLARE LONG EndPaint IN User32 LONG HWND, STRING @lpPaint
		DECLARE LONG GetWindowLong IN User32 LONG HWND, INTEGER nIndex && GetWindowLongPtr
		DECLARE LONG GetWindow IN Win32API LONG HWND, LONG uCmd
		*!*	DECLARE LONG CallWindowProc IN User32 ;
		INTEGER lpPrevWndFunc, LONG HWND, ;
		INTEGER Msg ,INTEGER wParam, ;
		INTEGER lParam
		*!*	DECLARE INTEGER DefWindowProc IN User32 ;
		LONG hWnd,LONG Msg,INTEGER wParam,;
		INTEGER lParam
		SET CLASSLIB TO (HOME(1) + "FFC\_gdiplus.vcx")
	ENDPROC

	PROCEDURE MOUSEDOWN
		LPARAMETERS nButton, nShift, nXCoord, nYCoord
		IF nButton = 2
			WITH THIS
				.MOUSEPOINTER= 15
				.originalxcoord = nXCoord
				.originalycoord = nYCoord
			ENDWITH
		ENDIF
	ENDPROC

	PROCEDURE MOUSEMOVE
		LPARAMETERS nButton, nShift, nXCoord, nYCoord
		IF nButton=2
			WITH THIS
				.surfacex = .surfacex + (nXCoord - .originalxcoord)
				.surfacey = .surfacey + (nYCoord - .originalycoord)
				.originalxcoord = nXCoord
				.originalycoord = nYCoord
				.resetgpobjects
				.drawshapes()
			ENDWITH
		ELSE
			THIS.MOUSEPOINTER= 0
		ENDIF
	ENDPROC

	PROCEDURE INIT
		#DEFINE GW_CHILD 5
		#DEFINE GWL_WNDPROC -4
		#DEFINE WM_ERASEBKGND 0x0014
		#DEFINE WM_PAINT 0x000F

		WITH THIS
			.realhwnd = IIF(.SHOWWINDOW = 2, GetWindow(.HWND,GW_CHILD), .HWND)
			*!* can use SYS(2327, SYS(2325, SYS(2326,.hwnd))) instead of GetWindow() in VFP9

			*!*	.winprocaddress = GetWindowLong(.realhwnd, GWL_WNDPROC)

			=BINDEVENT(.realhwnd, WM_ERASEBKGND, THIS,'WinEventHandler')
			=BINDEVENT(.realhwnd, WM_PAINT, THIS, "WinEventHandler")
			.creategpobjects()
			.resetgpobjects()
		ENDWITH
	ENDPROC

	PROCEDURE RESIZE
		THIS.resetgpobjects
		THIS.drawshapes()
	ENDPROC

	PROCEDURE DESTROY
		UNBINDEVENTS(0)
		WITH THIS
			STORE NULL TO .gpbitmap, .gpcolor, .gppen, ;
				.gprect, .gpgraphicsdb, .gpsolidbrush, ;
				.gpgraphics, .gpimage
		ENDWITH
	ENDPROC

ENDDEFINE
