*******************************************************************
* SendEmail class library
* September 2004. News2News
*******************************************************************
* The following code sends plain-text message with attached file
* using SMTP server.
*
* Put valid names for smtp server, sender, recipients ...
*
* The dialog with the server (if any) will be displayed on
* the main FoxPro window. To supress it edit mailgate_smtp.addlog
*******************************************************************
CLEAR
CLEAR ALL
SET MEMOWIDTH TO 120
SET CLASSLIB TO SendEmail ADDITIVE
#DEFINE CRLF  CHR(13)+CHR(10)
#DEFINE DCRLF CRLF+CRLF

***************** replace with valid strings **********************
LOCAL smtpserver, sender, recipient, subject, body, filename
smtpserver = "smtp8.?????.com"
sender = "??@??????.com"
recipient = "??@???.com"
subject = "Test message"  && message subject
body = "This is a test message, no reply please." && message body
filename = FULLPATH("sendemail.zip")  && file to be attached to the message
*******************************************************************

	LOCAL msg As msg

	* create and populate message
	msg = CREATEOBJECT("msg")
	WITH msg
		.subject = m.subject

		.setsender(m.sender, "FoxPro developer")
		.addrecipient(m.recipient, "Buddy of foxpro developer")

		.addpart(m.body, "text/plain", "7bit")
		.addattachment(m.filename)
	ENDWITH
	
	* create smtp mailgate and connect to the server by passing its name
	* to the new object
	LOCAL gate As mailgate
	gate = CREATEOBJECT("mailgate_smtp", m.smtpserver)

	IF NOT gate.isconnected()
		= MESSAGEBOX("Error: " + TRANSFORM(gate.errorcode) +;
			". " + gate.errormsg + "     ",;
			48, "SendEmail class library")
		RETURN
	ENDIF

	IF NOT gate.sendmessage(m.msg)
		= MESSAGEBOX("Error: " + TRANSFORM(gate.errorcode) +;
			". " + gate.errormsg + "     ",;
			48, "SendEmail class library")
	ELSE
		gate.disconnect
		= MESSAGEBOX("Email sent successfully!     ",;
			64, "SendEmail class library")
	ENDIF
