* Projection (Sub-select as part of field list and 
* complex expression)
* Sales total by customer with PCT of All customer sales

CLOSE DATABASES ALL
OPEN DATABASE Northwind

SELECT ;
   C.customerID, ;
   C.companyname, ;
   SUM(D.quantity*D.unitprice) AS CustTotal ,;   
   (SUM(D.quantity*D.unitprice) / ;
     (SELECT SUM((quantity*unitprice)-discount) ;
        FROM OrderDetails D2) ;
    )*100 AS PctTotal ;
  FROM Customers C ;
 INNER JOIN Orders O ;
    ON C.customerID = O.customerID ;
 INNER JOIN OrderDetails D ;
    ON O.orderid = D.orderid ;
 GROUP BY C.customerID, C.companyname, O.orderID ;
 ORDER BY pctTotal DESC
 
 CLOSE DATABASES ALL
