*******************************************************************
* SendEmail class library
* September 2004. News2News
*******************************************************************
* The following code creates, populates and opens preview 
* for a message object.
*
* The message is not going to be sent anywhere.
*******************************************************************
CLEAR
CLEAR ALL
SET MEMOWIDTH TO 120
SET CLASSLIB TO SendEmail ADDITIVE
#DEFINE CRLF  CHR(13)+CHR(10)
#DEFINE DCRLF CRLF+CRLF

	LOCAL msg As msg, oPart As msg_part, cBody, ex As Exception

	msg = CREATEOBJECT("msg")  && message object
	WITH msg
		.subject = "Test message"
		.addheader("Mime-Version", "1.0")

		.addheader("Importance", "Normal")
*		.addheader("X-MSMail-Priority", "High")

		.addheader("Return-Path", "info@foxpro.com")
		.addheader("Disposition-Notification-To", '"Jane Brown" <developer@foxpro.com>')
		.addheader("X-AnyHeader", "any value for this header")

		.setsender("developer@foxpro.com", "FoxPro developer")

		* number of recipients may be limited by SMTP header itself
		* programmatically there's hardly a limit
		* 0 means To:, 1 means Cc:, 2 means Bcc:
		.addrecipient("andrew@portal.com", "Andrew", 0)  && To:
		.addrecipient("laura@portal.com", "Laura", 1) && Cc:
		.addrecipient("nicole@portal.com", "Nicole", 1) && Cc:
		.addrecipient("boss@foxpro.com", "Laura", 2)  && Bcc:
	ENDWITH

	* adding plain text body part
	cBody = "This is a test message, please no reply."
	oPart = msg.addpart(m.cBody, "text/plain", "7bit")
	
	* at this stage you have to enter content-type, encoding
	* and disposition manually
		
	* adding html alternative to the body part
	* strtohtml works pretty lame so far
	oPart.addpart(msg.strtohtml(cBody, .T.), "text/html", "7bit")
	
	* adding attachment using simplified addattachment routine
	* the addpart can be used for adding attachments too
	SET SAFETY OFF
	STRTOFILE(REPLICATE(m.cBody+CRLF, 10), "tmp.txt")
	SET SAFETY ON
	msg.addattachment("tmp.txt")
	
	IF NOT msg.addattachment("sendemail.zip")
*		= MESSAGEBOX("Could not attach sendemail.zip.     ",;
*			48, "SendEmail class library")
	ENDIF

	* a dumb mailgate is used for previewing this message
	* it's not connected to any mail server
	LOCAL gate As mailgate
	gate = CREATEOBJECT("mailgate_dumb")
	WITH gate
		IF .connect() && always True for the dumb mailgate
			IF .sendmessage(msg)
				SET SAFETY OFF
				STRTOFILE(gate.msgbuffer, "tmp.txt")  && preview file
				SET SAFETY ON
				MODIFY FILE tmp.txt NOWAIT
			ENDIF
		ENDIF
	ENDWITH

	* generally speaking what you get in this preview file
	* can be sent straight to any SMTP or Hotmail server
	
	* two other mailgates -- mailgate_smtp and mailgate_hotmail
	* can communicate with real mail servers

