local loPreview, ;
	loHandler, ;
	loListener

* Create the preview proxy object and set the desired properties.

do (_reportpreview) with loPreview
with loPreview
	.AllowPrintFromPreview = .F.
	.Caption   = 'This is my report'
	.Top       = 10
	.Left      = 10
	.Height    = 500
	.Width     = 500
	.ZoomLevel = 10  && whole page
	loHandler  = createobject('SFPreviewExtensionHandler')
	.SetExtensionHandler(loHandler)
endwith

* Create a listener object and tell it to use our preview object.

loListener = createobject('ReportListener')
loListener.ListenerType     = 1
loListener.PreviewContainer = loPreview

* Run the report using the listener.

use _samples + 'Northwind\Orders'
report form TestPreview.FRX preview object loListener

define class SFPreviewExtensionHandler as Custom
	PreviewForm = .NULL.

* Dock the toolbar if there is one.

	procedure Show(tnStyle)
		if vartype(This.PreviewForm) = 'O'
			This.PreviewForm.Toolbar.Dock(0)
		endif vartype(This.PreviewForm) = 'O'
	endproc

* Clean up when we're released.

	procedure Release
		if type('This.PreviewForm') = 'O'
			This.PreviewForm.ExtensionHandler = .NULL.
			This.PreviewForm = .NULL.
		endif type('This.PreviewForm') = 'O'
	endproc

	procedure AddBarsToMenu(tcShortcutMenuName, tnBarCount)
	endproc

	procedure HandledKeyPress(tnKeyCode, tnShiftAltCtrl)
	endproc

	procedure Paint
	endproc
enddefine
