* Demonstrate correlated UPDATE (UPDATE ... FROM ..)
* UPDATE unitprice of products from mfg_msrp with 10% 
* off MSRP

CLOSE DATABASES ALL
SET MULTILOCKS ON
OPEN DATABASE Northwind
CLEAR

? "Procedural REPLACE FOR"
lnStart = SECONDS()
USE Products IN 0
CURSORSETPROP("Buffering",5,"Products")
USE Mfg_msrp IN 0
SELECT Mfg_msrp
SCAN
   SELECT Products 
   REPLACE ALL unitprice WITH mfg_msrp.msrp*.90 ;
   		FOR Products.ProductID = mfg_msrp.ProductID
   SELECT mfg_msrp
ENDSCAN
? SECONDS() - m.lnStart

SELECT Products
=TABLEREVERT(.T.)
CLOSE TABLES ALL

? "Correlated UPDATE"

lnStart = SECONDS()
USE Products IN 0
CURSORSETPROP("Buffering",5,"Products")
UPDATE products ;
	SET unitprice = mfg_msrp.msrp*.90 ;
	FROM mfg_msrp ;
	WHERE mfg_msrp.productID = products.productID;
	AND mfg_msrp.discontinu = .F.

? SECONDS() - m.lnStart
SELECT Products
=TABLEREVERT(.T.)
CLOSE DATABASES ALL
